<template>
  <transition name="modal-transition" appear>
    <div
      v-show="showing"
      class="sa-modal"
      :data-testid="title"
      tabindex="0"
      :aria-hidden="showing ? null : 'true'"
      :aria-modal="showing ? 'true' : null"
      @keydown.esc.prevent="_closeModal"
    >
      <div class="background-fill" @click.self="_closeModal">
        <div class="modal" :class="{ 'full-width': fullWidth }">
          <div class="header">
            <h2>{{ title }}</h2>
          </div>

          <div v-if="$slots.body" class="body">
            <!-- @slot Main content for modal -->
            <slot name="body" />
          </div>

          <div v-if="$slots.footer" class="footer">
            <!-- @slot Footer content for modal -->
            <slot name="footer" />
          </div>
        </div>
      </div>
    </div>
  </transition>
</template>

<script>
export default {
  name: 'SaModal',
  props: {
    /** Title of modal popup */
    title: {
      type: String,
      required: true
    },
    /** Optional ID used to connect to modal to a button */
    id: {
      type: String,
      default: () => 'modal-' + Math.floor(100000 * Math.random())
    },
    /** CSS class to add to the `body` tag when the modal is displayed */
    bodyClass: {
      type: String,
      default: 'noscroll'
    },
    /** Allow the modal to grow to the full width of the page */
    fullWidth: {
      type: Boolean,
      default: false
    },
    /** Whether the user is able to dismiss the modal by clicking outside */
    strict: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      showing: false
    }
  },
  mounted() {
    this.$root.$on('modal-toggle', this.onModalToggleEvent)
    this.$el.addEventListener('transitionend', this.removeBodyClass)
    this.$el.addEventListener('transitioncancel', this.removeBodyClass)
  },
  beforeDestroy() {
    this.$root.$off('modal-toggle', this.onModalToggleEvent)
    this.$el.removeEventListener('transitionend', this.removeBodyClass)
    this.$el.removeEventListener('transitioncancel', this.removeBodyClass)
  },
  methods: {
    onModalToggleEvent(id) {
      if (id === this.id) {
        this.toggleModal()
      }
    },
    toggleModal() {
      if (this.showing) {
        this.closeModal()
      } else {
        this.openModal()
      }
    },
    openModal() {
      if (!this.showing) {
        this.showing = true
        if (this.bodyClass) {
          document.body.classList.add(this.bodyClass)
        }
        /** Modal has been shown */
        this.$emit('open')
        this.$nextTick(() => this.$el.focus())
      }
    },
    _closeModal() {
      if (!this.strict) {
        this.closeModal()
      }
    },
    closeModal() {
      if (this.showing) {
        this.showing = false
        /** Modal has been hidden */
        this.$emit('close')
      }
    },
    removeBodyClass() {
      // called when transitions end or are cancelled
      const { classList } = document.body
      const { showing, bodyClass } = this
      if (!showing && bodyClass && classList.contains(bodyClass)) {
        classList.remove(bodyClass)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.sa-modal {
  transition: $transition;
}

.modal-transition {
  &-enter,
  &-leave-to {
    .background-fill {
      opacity: 0;
    }
    .modal {
      transform: translateY(1rem);
    }
  }
}

.modal {
  background: color(white);
  border-radius: $border-radius;
  box-shadow: $box-shadow;
  padding: spacing(3);
  display: flex;
  flex-direction: column;
  max-height: 100%;
  transform: translateY(0);
  transition: $transition;

  @media (min-width: 480px) {
    max-width: 50%;

    &.full-width {
      max-width: 100%;
    }
  }
}

.header h2 {
  padding-bottom: spacing(2);
  border-bottom: border(grey-light);
}

.body {
  overflow-y: auto;
  margin: spacing(2) 0;
}

.background-fill {
  position: fixed;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
  display: flex;
  align-items: center;
  justify-content: center;
  padding: spacing(2);
  background: rgba(color(primary-dark), 0.8);
  z-index: 101;
  transition: $transition;
}
</style>
